#!/usr/bin/env python
# -*- coding: cp1252 -*-
##
##    Copyright (C) 2006 manatlan manatlan[at]gmail(dot)com
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##


from __main__ import JPlugin
from datetime import datetime

from pycasaweb import GoogleConnection,PycasaWeb


class Plugin(JPlugin):
    """Plugin to upload some photos to a flickr account"""

    __author__ = "manatlan"
    __version__ = "1.0"

    def menuEntries(self,l):
        return [(8512,_("Upload to PicasaWeb"),False,self.upload,None)]

    def upload(self,list):
        from window import Window

        # default values
        email = self.conf["email"] or ""
        password = self.conf["password"] or ""
        public = self.conf["public"] or False

        # pass params to the window
        win = Window(email,password,public)
        ret=win.loop()[0]

        # analyze response
        if ret:
            email,password,public = ret

            # store default values
            self.conf["email"]=email
            self.conf["password"]=password
            self.conf["public"]=public

            # and batch the upload
            try:
                try:
                    picasa = PycasaWeb(email,password)
                    album=picasa.createAlbum("Jbrout export "+str(datetime.now()),public=self.conf["public"])

                    for i in list:
                        info = "%d/%d" % (list.index(i)+1, len(list))
                        self.showProgress( list.index(i), len(list) , _("uploading")+" "+info )
                        album.uploadPhoto(i.file,i.comment)
                except Exception,err:
                    self.MessageBox(_("Upload error : ")+str(err))
            finally:
                self.showProgress()

            return True
        else:
            return False
